<a href="https://opensource.org/licenses/MIT"><img src="https://img.shields.io/badge/license-MIT-yellow.svg" alt="License: MIT"></a>
<a href="https://github.com/tenhobi/effective_dart"><img src="https://img.shields.io/badge/style-effective_dart-blue.svg" alt="style: effective dart"></a>
<a href="https://travis-ci.org/github/owczaro/deep_collection"><img src="https://travis-ci.org/owczaro/deep_collection.svg?branch=master" alt="Travis CI"></a>

---


# DeepCollection

Extends `List`, `Set` and `Map` in order to add commonly used recursive methods such as sorting, reversing, finding intersections or differences.

## Supported operations

### List

- Deeply sort (by values)
- Deeply reverse

### Set

- Deeply sort (by values)
- Deeply reverse

### Map

- Deeply sort (by keys or values)
- Deeply reverse
- Deeply find intersections (by keys and values) - does not accept nested [List] or [Set]
- Deeply find differences (by keys and values) - does not accept nested [List] or [Set]


## Implementation

Visit [pub.dev -> install](https://pub.dev/packages/deep_collection/install) and [pub.dev -> example](https://pub.dev/packages/deep_collection/example).


## Commercial Use

If you use this code in commercial project, please donate me via GitHub Sponsors. I do the same for packages which I use, because it ensures stable development for all of us!
